#ifndef COMMON
#define COMMON

#define SAFE_DELETE(p) { if(p){ delete(p); (p) = NULL; } }
#define SAFE_DELETE_ARRAY(p) { if(p){ delete[](p); (p) = NULL; } }

typedef unsigned int u4;
typedef unsigned short u2;
typedef unsigned char u1;

typedef char jByte;
typedef short jShort;
typedef int jInt;
typedef long long jLong;
typedef unsigned long long jULong;
typedef float jFloat;
typedef double jDouble;
typedef unsigned short jChar;

#define ACC_PUBLIC			0x0001
#define ACC_PRIVATE			0x0002
#define ACC_PROTECTED		0x0004
#define ACC_STATIC			0x0008
#define ACC_FINAL			0x0010
#define ACC_SYNCHRONIZED	0x0020
#define ACC_SUPER			0x0020
#define ACC_VOLATILE		0x0040
#define ACC_TRANSIENT		0x0080
#define ACC_INTERFACE		0x0200
#define ACC_ABSTRACT		0x0400

//-----------------------------------------------------------------------------
//  Name: ReadU1()
//! Read u1 from file (big-endian).
//-----------------------------------------------------------------------------
u1 ReadU1(FILE *f);

//-----------------------------------------------------------------------------
//  Name: ReadU2()
//! Read u2 from file (big-endian).
//-----------------------------------------------------------------------------
u2 ReadU2(FILE *f);

//-----------------------------------------------------------------------------
//  Name: ReadU4()
//! Read u4 from file (big-endian).
//-----------------------------------------------------------------------------
u4 ReadU4(FILE *f);

#endif