
class cJVM;
class cJavaClass;

//-----------------------------------------------------------------------------
//  Name: struct OBJECT_HEADER
//! Represents heap allocated object header
//-----------------------------------------------------------------------------
typedef struct OBJECT
{
	u4	iSize;
	u4	iArraySize;
	cJavaClass	*pClass;
	//object data follows this header

} OBJECT;

//-----------------------------------------------------------------------------
// Name: class cHeap
// Desc: Implements script heap
//-----------------------------------------------------------------------------
class cHeap
{
private:
	//Heap memory
	u1		*m_pMainMemory;
	//Memory size
	u4		m_iMemorySize;
	//Top of heap memory
	u4		m_iTop;
	//Half heap boundry
	u4		m_iBoundry;
	//Heap owner
	cJVM	*m_pOwner;

public:
	//Constructor
	cHeap();

	//Destructor
	~cHeap();

	//Set heap owner
	void SetOwner(cJVM *pOwner);

	//Get number of allocated bytes
	u4 GetNumAllocatedBytes();

	//Initialize heap
	void Init(u4 iHeapSize);

	OBJECT* AllocateClass(cJavaClass *pClass);
	OBJECT* AllocateArray(cJavaClass *pClass, int iCount, int iItemSize);

	//Swap heap space
	void SwapHeapspace();

	//Relocate object - used during garbage collection
	OBJECT* RelocateObject(OBJECT *pObj);
};